﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Diagnostics;

namespace WpfControlTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        TurningViewModel _turningViewModel = new TurningViewModel() {  Hue = 1, Brightness = 20, Contrast = 2};
        public MainWindow()
        {
            try
            {
                InitializeComponent();
            }
            catch (Exception ex)
            {

            }
            this.DataContext = _turningViewModel;
        }

        private void get_Click(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine(string.Format("Hue:{0}",_turningViewModel.Hue));
            Debug.WriteLine(string.Format("Brightness:{0}", _turningViewModel.Brightness));
            Debug.WriteLine(string.Format("Contrast:{0}", _turningViewModel.Contrast));
        }
    }

    public class TurningViewModel : INotifyPropertyChanged
    {
        #region Hue
        private double _hue;
        public double Hue
        {
            get { return _hue; }
            set
            {
                if (_hue != value)
                {
                    _hue = value;
                    NotifyPropertyChanged("Hue");
                }
            }
        }
        #endregion

        #region Brightness
        private double _brightness;
        public double Brightness
        {
            get { return _brightness; }
            set
            {
                if (_brightness != value)
                {
                    _brightness = value;
                    NotifyPropertyChanged("Brightness");
                }
            }
        }
        #endregion

        #region Contrast
        private double _contrast;
        public double Contrast
        {
            get { return _contrast; }
            set
            {
                if (_contrast != value)
                {
                    _contrast = value;
                    NotifyPropertyChanged("Contrast");
                }
            }
        }
        #endregion

        void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
