﻿using System.Windows;
using System.Windows.Controls;

namespace WpfControlTest
{
    /// <summary>
    /// when value changed,use eventhandle to notify
    /// </summary>
    /// <param name="value"></param>
    public delegate void CustomSliderEventHandle(double value);

    public partial class UCSlider : UserControl
    {
        public UCSlider()
        {
            InitializeComponent();
            sl.ValueChanged += new RoutedPropertyChangedEventHandler<double>(sl_ValueChanged);
        }

        #region event
        public event CustomSliderEventHandle ValueChange;

        void sl_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (ValueChange != null)
                ValueChange(sl.Value);
        }
        #endregion

        #region Text
        public string Text
        {
            get { return (string)GetValue(TextProperty); }
            set { SetValue(TextProperty, value); }
        }

        public static DependencyProperty TextProperty = DependencyProperty.Register("Text", typeof(string), typeof(UCSlider));
        #endregion

        #region Maximum
        public double Maximum
        {
            get { return (double)GetValue(MaximumProperty); }
            set { SetValue(MaximumProperty, value); }
        }

        public static DependencyProperty MaximumProperty = DependencyProperty.Register("Maximum", typeof(double), typeof(UCSlider));
        #endregion

        #region Minimum
        public double Minimum
        {
            get { return (double)GetValue(MinimumProperty); }
            set { SetValue(MinimumProperty, value); }
        }

        public static DependencyProperty MinimumProperty = DependencyProperty.Register("Minimum", typeof(double), typeof(UCSlider));
        #endregion

        #region SliderValue
        public double SliderValue
        {
            get { return (double)GetValue(SliderValueProperty); }
            set { SetValue(SliderValueProperty, value); }
        }

        public static DependencyProperty SliderValueProperty = DependencyProperty.Register("SliderValue", typeof(double), typeof(UCSlider));
        #endregion
    }
}
